﻿using DesktopTools.Models;
using ModuleTools.Enums;
using System;

namespace DesktopTools.Interfaces
{
	/// <summary>
	/// Основные параметры для контрола
	/// </summary>
	public interface IControl
	{
		/// <summary>
		/// Идентификатор контрола
		/// </summary>
		public Guid ControlId { get; }

		/// <summary>
		/// Заголовок контрола
		/// </summary>
		string Title { get; }

		/// <summary>
		/// Операция в системе
		/// </summary>
		public AccessOperation AccessOperation { get; }

		/// <summary>
		/// Создание дубликата
		/// </summary>
		/// <returns></returns>
		IControl GetInstance();

		/// <summary>
		/// Открытие контрола
		/// </summary>
		/// <param name="model"></param>
		void Open(ControlOpenModel model);
	}
}